function L = fd_rpca_fone(M,W,ks,tau)

	%%please set W as all one matrix (i.e. ones(m,n)), not needed for all experiments in the conference paper!!
	% tau = 5e+4; %%sparsee noise estimate, get from "main" function outside, tune this parameter for different data, this parameter is pretty crucial for the performance of the algorithm, so please tune it carefully
	epsilon = 1e-3;%stopping criterion
	% ks = 1; %%get from "main" function outside, tune this parameter for different data, in paper we set it to equal or slightly larger than target rank
	% Mscale = norm(M(:),inf);
	% M = M / Mscale; %% M is the input matrix

	innerMAX = 10;
	tmax =1000;
	p =2;%% not needed for the conference paper!!
	
	[m,n] = size(M);
	Gamma_val = zeros(m,n);
	Gamma_hat = zeros(m,n);
	lambda = 1;
	g = zeros(m,n);
	omega_bar = 0;
	L = zeros(m,n); %% target low rank matrix
	flag = 0;
	% Hnu = 1e-4;
	% Hout = Hnu*Hnu/epsilon;
	% Hout = 1/epsilon;
	Houter =4; %initial H (i.e. inverse of step size), tune this for different settings
 	
	flag = 0;
	% Houter_init = 200; %tune this for different settings
	% ttt = 0.5*(norm(M,'fro')^2);
	ttt = 2; %%NIPS paper author mentioned different settings for this parameter, but we observe that 2 works fine for our cases
	count = 0;
	count2 = 0;
	needsearchcnt = 0;
	NC = 6; %line search for every 6 iterations (in paper we mention 5-10), tune this for different settings
	for t = 1:tmax
		g_old = g;
		Gamma_hat_old = Gamma_hat;
		Gamma_old = Gamma_val;
		[Lsharp,dual_val,Ut,st,Vt] = k_support_polar(-W.*Gamma_hat*ttt/2,ks,p);%polar of k-support norm
		% Lsharp = Lsharp*ttt;
		% g = W.*M - W.*Lsharp;%gradient of current iteration
		fouter = dual_val*dual_val*0.25 + trace(Gamma_hat'*M);
		g = M-Lsharp;
		%begin new line search
		if(needsearchcnt >= NC)
			needsearchcnt = 0;
			Hinner = Houter;
			flag = 0;
			flag2 = 0;
			Hold = Houter
			for innercount = 1:innerMAX
				%begin line search
				Gamma_inner = prox_infty(Gamma_hat-g/(Hinner),tau/Hinner);

				finner = ksupport_dual_func(Gamma_inner,W,M,ks,p,ttt); 
				% fouter = ksupport_dual_func(Gamma_hat,W,M,ks,p,ttt);%to be ajusted later
				% finner - fouter
				differ = finner - fouter - trace(g'*(Gamma_inner-Gamma_hat)) ...
				 		- 0.5*Hinner*((norm(Gamma_inner-Gamma_hat,'fro'))^2);
				% differ = finner-fouter + norm(g,'fro')/(2*Hinner);
				if(differ<(0.5*epsilon/lambda))
					break;
				else
					if count <=1 %% if not needed, set to 1
						flag = 1;
						break;
					else
						Hinner = 2*Hinner;
						flag = 1;
						flag2 = 1;
					end
				end

			end
			%end search for Hinner
			Gamma_val = Gamma_inner;
			%%flag and flag2, count and count2 are used to heuristically added to "slow down" the increase of H (i.e. avoid step size descreasing too fast), 
			%%not required if you don't observe H "exploding", I think in almost all real data experiments for the conference version they are not used
			if flag == 1
				count = count +1;
			else
				count = 0;
			end
			
			if flag2==1
				count = 2;
				count2 = count2 +1;
				if count2 >=1 %% if not needed, set to 1
					Houter = Hinner;
					count2 = 0;
					NC =NC;
				end
			end
			%end line search
		else %skip line search if needsearchcnt < #max
			Gamma_val = prox_infty(Gamma_hat-g/(Houter),tau/Houter);
			needsearchcnt = needsearchcnt + 1;
		end
		%update weight and primal sequence
		% Hout
		omega = lambda/Houter;
		omega_bar = omega_bar+omega;
		gamma_avg = omega/omega_bar;
		lambda_old = lambda;
		lambda = 0.5 + 0.5*(1+4*lambda_old*lambda_old)^0.5;
		Gamma_hat = Gamma_val+((lambda_old-1)/lambda)*(Gamma_val-Gamma_old);
		L_old = L;
		% gamma_avg = 2/(t+1);
		L = (1-gamma_avg)*L + gamma_avg * Lsharp;
		
		dL = L-L_old;
		if(sum(abs(dL(:)))/sum(abs(L_old(:)))<1e-3)
			break;
		end
	end%for end

end%function end

function Z = ksupport_dual_func(G,W,M,ks,p,ttt)
	[U,S,V] = lansvd(-W.*G*ttt/2,ks,'L');

	s = diag(S);
	Z = (1/ttt)*norm(s,2)^2/2+trace(G'*M);
end

%%compute linear oracle, require lansvd
function [polar,f,U,s,V] = k_support_polar(G,ks,p)
	[U,S,V] = lansvd(G,ks,'L');
	s = diag(S);
	f = norm(s,2);
	polar = U*S*V';
end

%%proximal map w.r.t infinite norm
function Ga=prox_infty(IN,taudH)
	Ga = IN - taudH*ProjectOntoL1Ball(IN/taudH,1);
end
